﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Data;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.TreeListView;

namespace Treelistview_Self_Hierarchy
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		private List<MyData> Data;

		public MainWindow()
		{	
			InitializeComponent();

			this.Data = (this.Resources["MyViewModel"] as MyViewModel).AllData;
		}

		private void tlv_RowIsExpandedChanging(object sender, Telerik.Windows.Controls.GridView.RowCancelEventArgs e)
		{
			MyData parent = e.Row.Item as MyData;
			if (parent.Children.Count <= 0)
			{
				var children = (from d in Data
								where d.ParentID == parent.ID
								select d);

				parent.Children.AddRange(children);	
			}		
		}

		private void tlv_RowLoaded(object sender, Telerik.Windows.Controls.GridView.RowLoadedEventArgs e)
		{
			if (e.Row is TreeListViewRow)
			{
				TreeListViewRow row = e.Row as TreeListViewRow;
				MyData context = row.Item as MyData;

				row.IsExpandable = (from d in Data
									where d.ParentID == context.ID
									select d).Count() > 0;
			}			
		}

		private void RadButton_Click(object sender, RoutedEventArgs e)
		{
			this.tlv.ItemsSource = (this.Resources["MyViewModel"] as MyViewModel).RootItems;
		}
	}
}
